include "Vdp.inc"
include "Vram.inc"

ext EnableNmi, DisableNmi, InitVdp, NmiEnabled
ext InitVram_, InitSound_, TempoValue
ext SoundHandler

NmiHook equ 7498h

    dseg
TimerCount: defb 0 public TimerCount


cseg
Init_: public Init_
    call InitVdp
    call InitSound_
    call EnableNmi
    ; di
        ld hl,Handler
        ld (NmiHook+1),hl
    ; ei
    call InitVram_
ret


Handler: public Handler
    push af
        ld a,(NmiEnabled)
        or a
        if nz
            ld a,(VdpAddress+1)
            and 80h
            if nz
                ld a,(TimerCount)
                or a
                if nz
                    dec a
                    ld (TimerCount),a
                endif
                call SoundHandler
            endif
        endif
    pop af
; ei
retn


WaitTimer_:
    public WaitTimer_
    push af
        ld (TimerCount),a
        do
            ld a,(TimerCount)
            or a
        while nz | wend
    pop af
ret
